commit:     454a039a0ff6d84719488b2433e6702f0cb54484
Author:     Brian Evans <grknight <AT> gentoo <DOT> org>
AuthorDate: Fri Dec 11 21:48:38 2015 +0000
Commit:     Brian Evans <grknight <AT> gentoo <DOT> org>
CommitDate: Fri Dec 11 21:48:38 2015 +0000
URL:        https://gitweb.gentoo.org/proj/mysql.git/commit/?id=454a039a

Push experimental eclass revision to test

Signed-off-by: Brian Evans <grknight <AT> gentoo.org>

 dev-db/mariadb/mariadb-10.1.9-r1.ebuild            |  207 ++++
 .../percona-server-5.6.26.74.0-r1.ebuild           |  173 ++++
 eclass/mysql-multilib-r1.eclass                    | 1043 ++++++++++++++++++++
 3 files changed, 1423 insertions(+)

diff --git a/dev-db/mariadb/mariadb-10.1.9-r1.ebuild 
b/dev-db/mariadb/mariadb-10.1.9-r1.ebuild
new file mode 100644
index 0000000..7ec76dd
--- /dev/null
+++ b/dev-db/mariadb/mariadb-10.1.9-r1.ebuild
@@ -0,0 +1,207 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI="5"
+MY_EXTRAS_VER="20151123-1643Z"
+# The wsrep API version must match between upstream WSREP and 
sys-cluster/galera major number
+WSREP_REVISION="25"
+SUBSLOT="18"
+MYSQL_PV_MAJOR="5.6"
+
+inherit toolchain-funcs mysql-multilib-r1
+
+HOMEPAGE="http://mariadb.org/";
+DESCRIPTION="An enhanced, drop-in replacement for MySQL"
+
+IUSE="bindist cracklib galera innodb-lz4 innodb-lzo innodb-snappy mroonga odbc 
oqgraph pam sphinx sst-rsync sst-xtrabackup tokudb systemd xml"
+RESTRICT="!bindist? ( bindist )"
+
+REQUIRED_USE="tokudb? ( jemalloc ) static? ( !pam )"
+
+# REMEMBER: also update eclass/mysql*.eclass before committing!
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~ia64 ~hppa ~mips ~ppc ~ppc64 ~s390 ~sh 
~sparc ~x86 ~sparc-fbsd ~x86-fbsd ~x86-freebsd ~amd64-linux ~x86-linux 
~ppc-macos ~x64-macos ~x86-macos ~x64-solaris ~x86-solaris"
+
+# When MY_EXTRAS is bumped, the index should be revised to exclude these.
+#EPATCH_EXCLUDE=''
+
+COMMON_DEPEND="
+       mroonga? ( app-text/groonga-normalizer-mysql )
+       systemd? ( sys-apps/systemd:= )
+       !bindist? ( >=sys-libs/readline-4.1:0=  )
+       server? (
+               cracklib? ( sys-libs/cracklib:0= )
+               extraengine? (
+                       odbc? ( dev-db/unixODBC:0= )
+                       xml? ( dev-libs/libxml2:2= )
+               )
+               innodb-lz4? ( app-arch/lz4 )
+               innodb-lzo? ( dev-libs/lzo )
+               innodb-snappy? ( app-arch/snappy )
+               oqgraph? ( >=dev-libs/boost-1.40.0:0= dev-libs/judy:0= )
+               pam? ( virtual/pam:0= )
+       )
+       >=dev-libs/libpcre-8.35:3=
+"
+DEPEND="|| ( >=sys-devel/gcc-3.4.6 >=sys-devel/gcc-apple-4.0 )
+       ${COMMON_DEPEND}"
+RDEPEND="${RDEPEND} ${COMMON_DEPEND}
+       galera? (
+               sys-apps/iproute2
+               =sys-cluster/galera-${WSREP_REVISION}*
+               sst-rsync? ( sys-process/lsof )
+               sst-xtrabackup? ( net-misc/socat[ssl] )
+       )
+       perl? ( !dev-db/mytop
+               virtual/perl-Getopt-Long
+               dev-perl/TermReadKey
+               virtual/perl-Term-ANSIColor
+               virtual/perl-Time-HiRes )
+"
+# xtrabackup-bin causes a circular dependency if DBD-mysql is not already 
installed
+PDEPEND="galera? ( sst-xtrabackup? ( >=dev-db/xtrabackup-bin-2.2.4 ) )"
+
+MULTILIB_WRAPPED_HEADERS+=( /usr/include/mysql/mysql_version.h )
+
+src_configure(){
+       # bug 508724 mariadb cannot use ld.gold
+       tc-ld-disable-gold
+       local MYSQL_CMAKE_NATIVE_DEFINES="
+                       -DWITH_JEMALLOC=$(usex jemalloc system)
+                       -DWITH_PCRE=system
+       "
+       if use server ; then
+               # Federated{,X} must be treated special otherwise they will not 
be built as plugins
+               if ! use extraengine ; then
+                       MYSQL_CMAKE_NATIVE_DEFINES+="
+                               -DPLUGIN_FEDERATED=NO
+                               -DPLUGIN_FEDERATEDX=NO"
+               fi
+
+               MYSQL_CMAKE_NATIVE_DEFINES+="
+                       -DPLUGIN_OQGRAPH=$(usex oqgraph YES NO)
+                       -DPLUGIN_SPHINX=$(usex sphinx YES NO)
+                       -DPLUGIN_TOKUDB=$(usex tokudb YES NO)
+                       -DPLUGIN_AUTH_PAM=$(usex pam YES NO)
+                       -DPLUGIN_CRACKLIB_PASSWORD_CHECK=$(usex cracklib YES NO)
+                       -DPLUGIN_CASSANDRA=NO
+                       -DPLUGIN_SEQUENCE=$(usex extraengine YES NO)
+                       -DPLUGIN_SPIDER=$(usex extraengine YES NO)
+                       -DPLUGIN_CONNECT=$(usex extraengine YES NO)
+                       -DCONNECT_WITH_MYSQL=1
+                       -DCONNECT_WITH_LIBXML2=$(usex xml)
+                       -DCONNECT_WITH_ODBC=$(usex odbc)
+                       -DWITH_WSREP=$(usex galera)
+                       -DWITH_INNODB_LZ4=$(usex innodb-lz4)
+                       -DWITH_INNODB_LZO=$(usex innodb-lzo)
+                       -DWITH_INNODB_SNAPPY=$(usex innodb-snappy)
+               "
+
+               use mroonga || MYSQL_CMAKE_NATIVE_DEFINES+="-DWITHOUT_MROONGA=1"
+       fi
+       mysql-multilib-r1_src_configure
+}
+
+# Official test instructions:
+# USE='embedded extraengine perl server openssl static-libs' \
+# FEATURES='test userpriv -usersandbox' \
+# ebuild mariadb-X.X.XX.ebuild \
+# digest clean package
+multilib_src_test() {
+
+       if ! multilib_is_native_abi ; then
+               einfo "Server tests not available on non-native abi".
+               return 0;
+       fi
+
+       local TESTDIR="${BUILD_DIR}/mysql-test"
+       local retstatus_unit
+       local retstatus_tests
+
+       if use server ; then
+
+               # Bug #213475 - MySQL _will_ object strenously if your machine 
is named
+               # localhost. Also causes weird failures.
+               [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must 
NOT be named localhost"
+
+               if [[ $UID -eq 0 ]]; then
+                       die "Testing with FEATURES=-userpriv is no longer 
supported by upstream. Tests MUST be run as non-root."
+               fi
+               has usersandbox $FEATURES && eerror "Some tests may fail with 
FEATURES=usersandbox"
+
+               einfo ">>> Test phase [test]: ${CATEGORY}/${PF}"
+               addpredict /this-dir-does-not-exist/t9.MYI
+
+               # Run CTest (test-units)
+               cmake-utils_src_test
+               retstatus_unit=$?
+               [[ $retstatus_unit -eq 0 ]] || eerror "test-unit failed"
+
+               # Create a symlink to provided binaries so the tests can find 
them when client-libs is off
+               if ! use client-libs ; then
+                       ln -srf /usr/bin/my_print_defaults 
"${BUILD_DIR}/client/my_print_defaults" || die
+                       ln -srf /usr/bin/perror "${BUILD_DIR}/client/perror" || 
die
+                       mysql-multilib-r1_disable_test main.perror "String 
mismatch due to not building local perror"
+               fi
+
+               # Ensure that parallel runs don't die
+               export MTR_BUILD_THREAD="$((${RANDOM} % 100))"
+               # Enable parallel testing, auto will try to detect number of 
cores
+               # You may set this by hand.
+               # The default maximum is 8 unless MTR_MAX_PARALLEL is increased
+               export MTR_PARALLEL="${MTR_PARALLEL:-auto}"
+
+               # create directories because mysqladmin might run out of order
+               mkdir -p "${T}"/var-tests{,/log}
+
+               # These are failing in MariaDB 10.0 for now and are believed to 
be
+               # false positives:
+               #
+               # main.information_schema, 
binlog.binlog_statement_insert_delayed,
+               # main.mysqld--help, funcs_1.is_triggers, 
funcs_1.is_tables_mysql,
+               # funcs_1.is_columns_mysql main.bootstrap
+               # fails due to USE=-latin1 / utf8 default
+               #
+               # main.mysql_client_test, main.mysql_client_test_nonblock
+               # main.mysql_client_test_comp:
+               # segfaults at random under Portage only, suspect resource 
limits.
+               #
+               # plugins.cracklib_password_check
+               # Can randomly fail due to cracklib return message
+
+               for t in main.mysql_client_test main.mysql_client_test_nonblock 
\
+                       main.mysql_client_test_comp main.bootstrap \
+                       binlog.binlog_statement_insert_delayed 
main.information_schema \
+                       main.mysqld--help plugins.cracklib_password_check \
+                       funcs_1.is_triggers funcs_1.is_tables_mysql 
funcs_1.is_columns_mysql ; do
+                               mysql-multilib_disable_test  "$t" "False 
positives in Gentoo"
+               done
+
+               # Run mysql tests
+               pushd "${TESTDIR}" || die
+
+               # run mysql-test tests
+               perl mysql-test-run.pl --force --vardir="${T}/var-tests" 
--reorder
+
+               retstatus_tests=$?
+               [[ $retstatus_tests -eq 0 ]] || eerror "tests failed"
+               has usersandbox $FEATURES && eerror "Some tests may fail with 
FEATURES=usersandbox"
+
+               popd || die
+
+               # Cleanup is important for these testcases.
+               pkill -9 -f "${S}/ndb" 2>/dev/null
+               pkill -9 -f "${S}/sql" 2>/dev/null
+
+               failures=""
+               [[ $retstatus_unit -eq 0 ]] || failures="${failures} test-unit"
+               [[ $retstatus_tests -eq 0 ]] || failures="${failures} tests"
+               has usersandbox $FEATURES && eerror "Some tests may fail with 
FEATURES=usersandbox"
+
+               [[ -z "$failures" ]] || die "Test failures: $failures"
+               einfo "Tests successfully completed"
+
+       else
+               einfo "Skipping server tests due to minimal build."
+       fi
+}

diff --git a/dev-db/percona-server/percona-server-5.6.26.74.0-r1.ebuild 
b/dev-db/percona-server/percona-server-5.6.26.74.0-r1.ebuild
new file mode 100644
index 0000000..4df5953
--- /dev/null
+++ b/dev-db/percona-server/percona-server-5.6.26.74.0-r1.ebuild
@@ -0,0 +1,173 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI="5"
+MY_EXTRAS_VER="20150717-1707Z"
+SUBSLOT="18"
+PYTHON_COMPAT=( python2_7 )
+inherit toolchain-funcs python-any-r1 mysql-multilib-r1
+
+IUSE="pam tokudb tokudb-backup-plugin"
+
+# REMEMBER: also update eclass/mysql*.eclass before committing!
+KEYWORDS="~alpha ~amd64 ~arm ~ia64 ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 
~sparc-fbsd ~x86-fbsd ~x86-linux"
+HOMEPAGE="http://www.percona.com/software/percona-server";
+DESCRIPTION="An enhanced, drop-in replacement for MySQL from the Percona team"
+
+# When MY_EXTRAS is bumped, the index should be revised to exclude these.
+EPATCH_EXCLUDE=''
+
+COMMON_DEPEND="server? ( pam? ( virtual/pam:0= ) )
+       tokudb? ( app-arch/snappy )
+       tokudb-backup-plugin? ( dev-util/valgrind )
+       "
+
+DEPEND="${COMMON_DEPEND}
+       || ( >=sys-devel/gcc-3.4.6 >=sys-devel/gcc-apple-4.0 )
+       test? ( $(python_gen_any_dep 
'dev-python/mysql-python[${PYTHON_USEDEP}]') )"
+RDEPEND="${COMMON_DEPEND}"
+
+REQUIRED_USE="tokudb? ( jemalloc ) tokudb-backup-plugin? ( tokudb )"
+
+# Please do not add a naive src_unpack to this ebuild
+# If you want to add a single patch, copy the ebuild to an overlay
+# and create your own mysql-extras tarball, looking at 000_index.txt
+
+python_check_deps() {
+       has_version "dev-python/mysql-python[${PYTHON_USEDEP}]"
+}
+
+src_configure() {
+       local MYSQL_CMAKE_NATIVE_DEFINES="-DWITH_PAM=$(usex pam)"
+       if use tokudb ; then
+               # TokuDB Backup plugin requires valgrind unconditionally
+               MYSQL_CMAKE_NATIVE_DEFINES+="
+                       $(mysql-cmake_use_plugin tokudb TOKUDB)
+                       $(usex tokudb-backup-plugin '' 
-DTOKUDB_BACKUP_DISABLED=1)
+               "
+       fi
+}
+
+# Official test instructions:
+# USE='extraengine perl openssl static-libs' \
+# FEATURES='test userpriv -usersandbox' \
+# ebuild percona-server-X.X.XX.ebuild \
+# digest clean package
+multilib_src_test() {
+
+       if ! multilib_is_native_abi ; then
+               einfo "Server tests not available on non-native abi".
+               return 0;
+       fi
+
+       local TESTDIR="${CMAKE_BUILD_DIR}/mysql-test"
+       local retstatus_unit
+       local retstatus_tests
+
+       # Bug #213475 - MySQL _will_ object strenously if your machine is named
+       # localhost. Also causes weird failures.
+       [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be 
named localhost"
+
+       if use server ; then
+
+               if [[ $UID -eq 0 ]]; then
+                       die "Testing with FEATURES=-userpriv is no longer 
supported by upstream. Tests MUST be run as non-root."
+               fi
+               has usersandbox $FEATURES && eerror "Some tests may fail with 
FEATURES=usersandbox"
+
+               einfo ">>> Test phase [test]: ${CATEGORY}/${PF}"
+               addpredict /this-dir-does-not-exist/t9.MYI
+
+               # Run CTest (test-units)
+               cmake-utils_src_test
+               retstatus_unit=$?
+               [[ $retstatus_unit -eq 0 ]] || eerror "test-unit failed"
+
+               # Ensure that parallel runs don't die
+               export MTR_BUILD_THREAD="$((${RANDOM} % 100))"
+               # Enable parallel testing, auto will try to detect number of 
cores
+               # You may set this by hand.
+               # The default maximum is 8 unless MTR_MAX_PARALLEL is increased
+               export MTR_PARALLEL="${MTR_PARALLEL:-auto}"
+
+               # create directories because mysqladmin might right out of order
+               mkdir -p "${T}"/var-tests{,/log}
+
+               # Create a symlink to provided binaries so the tests can find 
them when client-libs is off
+               if ! use client-libs ; then
+                       ln -srf /usr/bin/my_print_defaults 
"${BUILD_DIR}/client/my_print_defaults" || die
+                       ln -srf /usr/bin/perror "${BUILD_DIR}/client/perror" || 
die
+                       mysql-multilib_disable_test main.perror "String 
mismatch due to not building local perror"
+               fi
+
+               # These are failing in Percona 5.6 for now and are believed to 
be
+               # false positives:
+               #
+               # main.information_schema, 
binlog.binlog_statement_insert_delayed,
+               # main.mysqld--help-notwin, binlog.binlog_mysqlbinlog_filter
+               # perfschema.binlog_edge_mix, perfschema.binlog_edge_stmt
+               # funcs_1.is_columns_mysql funcs_1.is_tables_mysql 
funcs_1.is_triggers
+               # engines/funcs.db_alter_character_set 
engines/funcs.db_alter_character_set_collate
+               # engines/funcs.db_alter_collate_ascii 
engines/funcs.db_alter_collate_utf8
+               # engines/funcs.db_create_character_set 
engines/funcs.db_create_character_set_collate
+               # fails due to USE=-latin1 / utf8 default
+               #
+               # main.mysql_client_test:
+               # segfaults at random under Portage only, suspect resource 
limits.
+               #
+               # main.percona_bug1289599
+               # Looks to be a syntax error in the test file itself
+               #
+               # main.variables main.myisam main.merge_recover
+               # fails due to ulimit not able to open enough files (needs 5000)
+               #
+               # main.mysqlhotcopy_archive main.mysqlhotcopy_myisam
+               # Called with bad parameters should be reported upstream
+               #
+
+               for t in main.mysql_client_test \
+                       binlog.binlog_statement_insert_delayed 
main.information_schema \
+                       main.mysqld--help-notwin 
binlog.binlog_mysqlbinlog_filter \
+                       perfschema.binlog_edge_mix perfschema.binlog_edge_stmt \
+                       funcs_1.is_columns_mysql funcs_1.is_tables_mysql 
funcs_1.is_triggers \
+                       main.variables main.myisam main.merge_recover \
+                       engines/funcs.db_alter_character_set 
engines/funcs.db_alter_character_set_collate \
+                       engines/funcs.db_alter_collate_ascii 
engines/funcs.db_alter_collate_utf8 \
+                       engines/funcs.db_create_character_set 
engines/funcs.db_create_character_set_collate \
+                       main.percona_bug1289599 main.mysqlhotcopy_archive 
main.mysqlhotcopy_myisam ; do
+                               mysql-multilib_disable_test  "$t" "False 
positives in Gentoo"
+               done
+
+               # Run mysql tests
+               pushd "${TESTDIR}"
+
+               # Set file limits higher so tests run
+               ulimit -n 3000
+               python_setup
+               # run mysql-test tests
+               perl mysql-test-run.pl --force --vardir="${T}/var-tests" \
+                       --testcase-timeout=30 --reorder
+               retstatus_tests=$?
+               [[ $retstatus_tests -eq 0 ]] || eerror "tests failed"
+               has usersandbox $FEATURES && eerror "Some tests may fail with 
FEATURES=usersandbox"
+
+               popd
+
+               # Cleanup is important for these testcases.
+               pkill -9 -f "${S}/ndb" 2>/dev/null
+               pkill -9 -f "${S}/sql" 2>/dev/null
+
+               failures=""
+               [[ $retstatus_unit -eq 0 ]] || failures="${failures} test-unit"
+               [[ $retstatus_tests -eq 0 ]] || failures="${failures} tests"
+               has usersandbox $FEATURES && eerror "Some tests may fail with 
FEATURES=usersandbox"
+
+               [[ -z "$failures" ]] || die "Test failures: $failures"
+               einfo "Tests successfully completed"
+
+       else
+
+               einfo "Skipping server tests due to minimal build."
+       fi
+}

diff --git a/eclass/mysql-multilib-r1.eclass b/eclass/mysql-multilib-r1.eclass
new file mode 100644
index 0000000..5969d6b
--- /dev/null
+++ b/eclass/mysql-multilib-r1.eclass
@@ -0,0 +1,1043 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+# @ECLASS: mysql-multilib.eclass
+# @MAINTAINER:
+# Maintainers:
+#      - MySQL Team <[email protected]>
+#      - Robin H. Johnson <[email protected]>
+#      - Jorge Manuel B. S. Vicetto <[email protected]>
+#      - Brian Evans <[email protected]>
+# @BLURB: This eclass provides common functions for mysql ebuilds
+# @DESCRIPTION:
+# The mysql-multilib-r1.eclass is the base eclass to build the mysql and
+# alternative projects (mariadb and percona) ebuilds.
+# Provider and version specific settings will be included in each ebuild.
+# It provides the src_unpack, src_prepare, src_configure, src_compile,
+# src_install, pkg_preinst, pkg_postinst, pkg_config and pkg_postrm
+# phase hooks.
+
+MYSQL_EXTRAS=""
+
+# @ECLASS-VARIABLE: MYSQL_EXTRAS_VER
+# @DESCRIPTION:
+# The version of the MYSQL_EXTRAS repo to use to build mysql
+# Use "none" to disable it's use
+[[ ${MY_EXTRAS_VER} == "live" ]] && MYSQL_EXTRAS="git-r3"
+
+inherit eutils systemd flag-o-matic ${MYSQL_EXTRAS} mysql_fx versionator \
+       multilib prefix toolchain-funcs user cmake-utils multilib-minimal
+
+#
+# Supported EAPI versions and export functions
+#
+
+case "${EAPI:-0}" in
+       5) ;;
+       *) die "Unsupported EAPI: ${EAPI}" ;;
+esac
+
+EXPORT_FUNCTIONS pkg_pretend pkg_setup src_unpack src_prepare src_configure 
src_compile src_install pkg_preinst pkg_postinst pkg_config
+
+#
+# VARIABLES:
+#
+
+# Shorten the path because the socket path length must be shorter than 107 
chars
+# and we will run a mysql server during test phase
+S="${WORKDIR}/mysql"
+
+[[ ${MY_EXTRAS_VER} == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z"
+if [[ ${MY_EXTRAS_VER} == "live" ]]; then
+       EGIT_REPO_URI="git://anongit.gentoo.org/proj/mysql-extras.git"
+       EGIT_CHECKOUT_DIR=${WORKDIR}/mysql-extras
+       EGIT_CLONE_TYPE=shallow
+fi
+
+# @ECLASS-VARIABLE: MYSQL_PV_MAJOR
+# @DESCRIPTION:
+# Upstream MySQL considers the first two parts of the version number to be the
+# major version. Upgrades that change major version should always run
+# mysql_upgrade.
+if [[ -z ${MYSQL_PV_MAJOR} ]] ; then 
MYSQL_PV_MAJOR="$(get_version_component_range 1-2 ${PV})" ; fi
+
+# @ECLASS-VARIABLE: MYSQL_VERSION_ID
+# @DESCRIPTION:
+# MYSQL_VERSION_ID will be:
+# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all 
[0..99]
+# This is an important part, because many of the choices the MySQL ebuild will 
do
+# depend on this variable.
+# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
+# We also strip off upstream's trailing letter that they use to respin tarballs
+MYSQL_VERSION_ID=""
+tpv="${PV%[a-z]}"
+tpv=( ${tpv//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
+for vatom in 0 1 2 3 ; do
+       # pad to length 2
+       tpv[${vatom}]="00${tpv[${vatom}]}"
+       MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
+done
+# strip leading "0" (otherwise it's considered an octal number by BASH)
+MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
+
+# This eclass should only be used with at least mysql-5.5.35
+mysql_version_is_at_least "5.5.35" || die "This eclass should only be used 
with >=mysql-5.5.35"
+
+# Work out the default SERVER_URI correctly
+if [[ -z ${SERVER_URI} ]]; then
+       if [[ ${PN} == "mariadb" ]]; then
+               # Beginning with 5.5, MariaDB stopped putting beta, alpha or rc 
on their tarball names
+               MARIA_FULL_PV=$(get_version_component_range 1-3)
+               MARIA_FULL_P="${PN}-${MARIA_FULL_PV}"
+               
SERVER_URI="https://downloads.mariadb.org/interstitial/${MARIA_FULL_P}/source/${MARIA_FULL_P}.tar.gz";
+       elif [[ ${PN} == "percona-server" ]]; then
+               PERCONA_PN="Percona-Server"
+               MIRROR_PV=$(get_version_component_range 1-2 ${PV})
+               MY_PV=$(get_version_component_range 1-3 ${PV})
+               PERCONA_RELEASE=$(get_version_component_range 4-5 ${PV})
+               PERCONA_RC=$(get_version_component_range 6 ${PV})
+               
SERVER_URI="http://www.percona.com/redir/downloads/${PERCONA_PN}-${MIRROR_PV}/${PERCONA_PN}-${MY_PV}-${PERCONA_RC}${PERCONA_RELEASE}/source/tarball/${PN}-${MY_PV}-${PERCONA_RC}${PERCONA_RELEASE}.tar.gz";
+       else
+               if [[ "${PN}" == "mysql-cluster" ]] ; then
+                       URI_DIR="MySQL-Cluster"
+                       URI_FILE="mysql-cluster-gpl"
+               else
+                       URI_DIR="MySQL"
+                       URI_FILE="mysql"
+               fi
+               [[ -z ${MY_PV} ]] && MY_PV="${PV//_/-}"
+               URI_A="${URI_FILE}-${MY_PV}.tar.gz"
+               MIRROR_PV=$(get_version_component_range 1-2 ${PV})
+               # Recently upstream switched to an archive site, and not on 
mirrors
+               
SERVER_URI="http://downloads.mysql.com/archives/${URI_FILE}-${MIRROR_PV}/${URI_A}";
+       fi
+fi
+
+# Define correct SRC_URIs
+SRC_URI="${SERVER_URI}"
+
+# Gentoo patches to MySQL
+if [[ ${MY_EXTRAS_VER} != "live" && ${MY_EXTRAS_VER} != "none" ]]; then
+       SRC_URI="${SRC_URI}
+               mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
+               
https://dev.gentoo.org/~grknight/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
+               
https://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
+               
https://dev.gentoo.org/~jmbsvicetto/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2";
+fi
+
+DESCRIPTION="A fast, multi-threaded, multi-user SQL database server"
+HOMEPAGE="http://www.mysql.com/";
+LICENSE="GPL-2"
+SLOT="0/${SUBSLOT:-0}"
+
+IUSE="debug embedded extraengine jemalloc latin1 libressl +openssl
+       +perl profiling selinux +server systemtap static static-libs tcmalloc 
test yassl"
+
+REQUIRED_USE="^^ ( yassl openssl libressl )"
+
+# Tests always fail when libressl is enabled due to hard-coded ciphers in the 
tests
+RESTRICT="libressl? ( test )"
+
+REQUIRED_USE="!server? ( !extraengine !embedded )
+        ?? ( tcmalloc jemalloc )
+        static? ( !libressl !openssl yassl )"
+
+#
+# DEPENDENCIES:
+#
+
+# Be warned, *DEPEND are version-dependant
+# These are used for both runtime and compiletime
+# MULTILIB_USEDEP only set for libraries used by the client library
+DEPEND="
+       kernel_linux? (
+               sys-process/procps:0=
+               dev-libs/libaio:0=
+       )
+       >=sys-apps/sed-4
+       >=sys-apps/texinfo-4.7-r1
+       !dev-db/mariadb-native-client[mysqlcompat]
+       jemalloc? ( dev-libs/jemalloc:0= )
+       tcmalloc? ( dev-util/google-perftools:0= )
+       systemtap? ( >=dev-util/systemtap-1.3:0= )
+       openssl? ( >=dev-libs/openssl-1.0.0:0=[${MULTILIB_USEDEP},static-libs?] 
)
+       libressl? ( dev-libs/libressl:0=[${MULTILIB_USEDEP},static-libs?] )
+       >=sys-libs/zlib-1.2.3:0=[${MULTILIB_USEDEP},static-libs?]
+       sys-libs/ncurses:0=
+"
+
+# prefix: first need to implement something for #196294
+RDEPEND="${DEPEND}
+       selinux? ( sec-policy/selinux-mysql )
+       abi_x86_32? ( !app-emulation/emul-linux-x86-db[-abi_x86_32(-)] )
+"
+
+# Having different flavours at the same time is not a good idea
+for i in "mysql" "mariadb" "mariadb-galera" "percona-server" "mysql-cluster" ; 
do
+       [[ ${i} == ${PN} ]] ||
+       RDEPEND="${RDEPEND} !dev-db/${i}"
+done
+
+RDEPEND="${RDEPEND}
+       server? ( !prefix? ( dev-db/mysql-init-scripts ) )
+       !<virtual/mysql-5.6-r4"
+
+# compile-time-only
+# ncurses only needs multilib for compile time due to a binary that will be 
not installed
+DEPEND="${DEPEND}
+       virtual/yacc
+       static? ( sys-libs/ncurses[static-libs] )
+"
+
+# For other stuff to bring us in
+# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
+PDEPEND="${PDEPEND} perl? ( >=dev-perl/DBD-mysql-2.9004 )
+        ~virtual/mysql-${MYSQL_PV_MAJOR}"
+
+# my_config.h includes ABI specific data
+MULTILIB_WRAPPED_HEADERS=( /usr/include/mysql/my_config.h 
/usr/include/mysql/private/embedded_priv.h )
+
+#
+# EBUILD FUNCTIONS
+#
+
+# @FUNCTION: mysql-multilib-r1_pkg_pretend
+# @DESCRIPTION:
+# Perform some basic tests and tasks during pkg_pretend phase:
+mysql-multilib-r1_pkg_pretend() {
+       if [[ ${MERGE_TYPE} != binary ]] ; then
+               local GCC_MAJOR_SET=$(gcc-major-version)
+               local GCC_MINOR_SET=$(gcc-minor-version)
+               if use_if_iuse tokudb && [[ ${GCC_MAJOR_SET} -lt 4 || \
+                       ${GCC_MAJOR_SET} -eq 4 && ${GCC_MINOR_SET} -lt 7 ]] ; 
then
+                       eerror "${PN} with tokudb needs to be built with 
gcc-4.7 or later."
+                       eerror "Please use gcc-config to switch to gcc-4.7 or 
later version."
+                       die
+               fi
+               # Bug 565584.  InnoDB now requires atomic functions introduced 
with gcc-4.7 on
+               # non x86{,_64} arches
+               if ! use amd64 && ! use x86 && [[ ${GCC_MAJOR_SET} -lt 4 || \
+                       ${GCC_MAJOR_SET} -eq 4 && ${GCC_MINOR_SET} -lt 7 ]] ; 
then
+                       eerror "${PN} needs to be built with gcc-4.7 or later."
+                       eerror "Please use gcc-config to switch to gcc-4.7 or 
later version."
+                       die
+               fi
+       fi
+}
+
+# @FUNCTION: mysql-multilib-r1_pkg_setup
+# @DESCRIPTION:
+# Perform some basic tests and tasks during pkg_setup phase:
+#   die if FEATURES="test", USE="server" and not using FEATURES="userpriv"
+#   create new user and group for mysql
+#   warn about deprecated features
+mysql-multilib-r1_pkg_setup() {
+
+       if has test ${FEATURES} && \
+               use server && ! has userpriv ${FEATURES} ; then
+                       eerror "Testing with FEATURES=-userpriv is no longer 
supported by upstream. Tests MUST be run as non-root."
+       fi
+
+       # This should come after all of the die statements
+       enewgroup mysql 60 || die "problem adding 'mysql' group"
+       enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' 
user"
+}
+
+# @FUNCTION: mysql-multilib-r1_src_unpack
+# @DESCRIPTION:
+# Unpack the source code
+mysql-multilib-r1_src_unpack() {
+
+       # Initialize the proper variables first
+       mysql_init_vars
+
+       unpack ${A}
+       # Grab the patches
+       [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" 
git-r3_src_unpack
+
+       mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
+}
+
+# @FUNCTION: mysql-multilib-r1_src_prepare
+# @DESCRIPTION:
+# Apply patches to the source code and remove unneeded bundled libs.
+mysql-multilib-r1_src_prepare() {
+
+       debug-print-function ${FUNCNAME} "$@"
+
+       cd "${S}"
+
+       if [[ ${MY_EXTRAS_VER} != none ]]; then
+
+               # Apply the patches for this MySQL version
+               EPATCH_SUFFIX="patch"
+               mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch 
directory"
+               # Clean out old items
+               rm -f "${EPATCH_SOURCE}"/*
+               # Now link in right patches
+               mysql_mv_patches
+               # And apply
+               epatch
+       fi
+
+       # last -fPIC fixup, per bug #305873
+       i="${S}"/storage/innodb_plugin/plug.in
+       if [[ -f ${i} ]] ; then sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}" 
|| die ; fi
+
+       rm -f "scripts/mysqlbug"
+       if use jemalloc && [[ ${PN} != "mariadb" ]] ; then
+               echo "TARGET_LINK_LIBRARIES(mysqld jemalloc)" >> 
"${S}/sql/CMakeLists.txt" || die
+       fi
+
+       if use tcmalloc; then
+               echo "TARGET_LINK_LIBRARIES(mysqld tcmalloc)" >> 
"${S}/sql/CMakeLists.txt"
+       fi
+
+       if in_iuse tokudb ; then
+               # Don't build bundled xz-utils
+               if [[ -d "${S}/storage/tokudb/ft-index" ]] ; then
+                       rm -f 
"${S}/storage/tokudb/ft-index/cmake_modules/TokuThirdParty.cmake" || die
+                       touch 
"${S}/storage/tokudb/ft-index/cmake_modules/TokuThirdParty.cmake" || die
+                       sed -i 's/ build_lzma//' 
"${S}/storage/tokudb/ft-index/ft/CMakeLists.txt" || die
+               elif [[ -d "${S}/storage/tokudb/PerconaFT" ]] ; then
+                       rm 
"${S}/storage/tokudb/PerconaFT/cmake_modules/TokuThirdParty.cmake" || die
+                       touch 
"${S}/storage/tokudb/PerconaFT/cmake_modules/TokuThirdParty.cmake" || die
+                       sed -i -e 's/ build_lzma//' -e 's/ build_snappy//' 
"${S}/storage/tokudb/PerconaFT/ft/CMakeLists.txt" || die
+                       sed -i -e 
's/add_dependencies\(tokuportability_static_conv build_jemalloc\)//' 
"${S}/storage/tokudb/PerconaFT/portability/CMakeLists.txt" || die
+               fi
+
+               if [[ -d "${S}/plugin/tokudb-backup-plugin" ]] && ! use 
tokudb-backup-plugin ; then
+                        rm -r 
"${S}/plugin/tokudb-backup-plugin/Percona-TokuBackup" || die
+               fi
+       fi
+
+       # Remove the bundled groonga if it exists
+       # There is no CMake flag, it simply checks for existance
+       if [[ -d "${S}"/storage/mroonga/vendor/groonga ]] ; then
+               rm -r "${S}"/storage/mroonga/vendor/groonga || die "could not 
remove packaged groonga"
+       fi
+
+       epatch_user
+}
+
+# @FUNCTION: mysql-multilib-r1_src_configure
+# @DESCRIPTION:
+# Configure mysql to build the code for Gentoo respecting the use flags.
+mysql-multilib-r1_src_configure() {
+       # Bug #114895, bug #110149
+       filter-flags "-O" "-O[01]"
+
+       CXXFLAGS="${CXXFLAGS} -fno-strict-aliasing"
+       CXXFLAGS="${CXXFLAGS} -felide-constructors"
+       # Causes linkage failures.  Upstream bug #59607 removes it
+       if ! mysql_version_is_at_least "5.6" ; then
+               CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
+       fi
+       # As of 5.7, exceptions are used!
+       if [[ ${PN} == "percona-server" ]] && mysql_version_is_at_least 
"5.6.26" ; then
+                CXXFLAGS="${CXXFLAGS} -fno-rtti"
+        elif ! mysql_version_is_at_least "5.7" ; then
+               CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-rtti"
+       fi
+       export CXXFLAGS
+
+       # bug #283926, with GCC4.4, this is required to get correct behavior.
+       append-flags -fno-strict-aliasing
+
+       multilib-minimal_src_configure
+}
+
+multilib_src_configure() {
+       debug-print-function ${FUNCNAME} "$@"
+
+       CMAKE_BUILD_TYPE="RelWithDebInfo"
+
+       # debug hack wrt #497532
+       mycmakeargs=(
+               -DCMAKE_C_FLAGS_RELWITHDEBINFO="$(usex debug '' '-DNDEBUG')"
+               -DCMAKE_CXX_FLAGS_RELWITHDEBINFO="$(usex debug '' '-DNDEBUG')"
+               -DCMAKE_INSTALL_PREFIX=${EPREFIX}/usr
+               -DMYSQL_DATADIR=${EPREFIX}/var/lib/mysql
+               -DSYSCONFDIR=${EPREFIX}/etc/mysql
+               -DINSTALL_BINDIR=bin
+               -DINSTALL_DOCDIR=share/doc/${PF}
+               -DINSTALL_DOCREADMEDIR=share/doc/${PF}
+               -DINSTALL_INCLUDEDIR=include/mysql
+               -DINSTALL_INFODIR=share/info
+               -DINSTALL_LIBDIR=$(get_libdir)
+               -DINSTALL_ELIBDIR=$(get_libdir)/mysql
+               -DINSTALL_MANDIR=share/man
+               -DINSTALL_MYSQLDATADIR=${EPREFIX}/var/lib/mysql
+               -DINSTALL_MYSQLSHAREDIR=share/mysql
+               -DINSTALL_MYSQLTESTDIR=share/mysql/mysql-test
+               -DINSTALL_PLUGINDIR=$(get_libdir)/mysql/plugin
+               -DINSTALL_SBINDIR=sbin
+               -DINSTALL_SCRIPTDIR=share/mysql/scripts
+               -DINSTALL_SQLBENCHDIR=share/mysql
+               -DINSTALL_SUPPORTFILESDIR=${EPREFIX}/usr/share/mysql
+               -DWITH_COMMENT="Gentoo Linux ${PF}"
+               -DWITH_UNIT_TESTS=$(usex test)
+               -DWITH_LIBEDIT=0
+               -DWITH_ZLIB=system
+               -DWITHOUT_LIBWRAP=1
+               -DENABLED_LOCAL_INFILE=1
+               -DMYSQL_UNIX_ADDR=${EPREFIX}/var/run/mysqld/mysqld.sock
+               -DINSTALL_UNIX_ADDRDIR=${EPREFIX}/var/run/mysqld/mysqld.sock
+               -DWITH_DEFAULT_COMPILER_OPTIONS=0
+               -DWITH_DEFAULT_FEATURE_SET=0
+               -DINSTALL_SYSTEMD_UNITDIR="$(systemd_get_unitdir)"
+       )
+
+       if in_iuse systemd ; then
+               mycmakeargs+=( -DWITH_SYSTEMD=$(usex systemd) )
+       fi
+
+       if use openssl || use libressl ; then
+               mycmakeargs+=( -DWITH_SSL=system )
+       else
+               mycmakeargs+=( -DWITH_SSL=bundled )
+       fi
+
+       if ! multilib_is_native_abi ; then
+               mycmakeargs+=( -DWITHOUT_TOOLS=1 )
+       fi
+
+       if in_iuse bindist ; then
+               # bfd.h is only used starting with 10.1 and can be controlled 
by NOT_FOR_DISTRIBUTION
+               if multilib_is_native_abi; then
+                       mycmakeargs+=(
+                               -DWITH_READLINE=$(usex bindist 1 0)
+                               -DNOT_FOR_DISTRIBUTION=$(usex bindist 0 1)
+                       )
+               else
+                       mycmakeargs+=(
+                               -DWITH_READLINE=1
+                               -DNOT_FOR_DISTRIBUTION=0
+                       )
+               fi
+       fi
+
+       ### TODO: make this system but issues with UTF-8 prevent it
+       mycmakeargs+=( -DWITH_EDITLINE=bundled )
+
+       if multilib_is_native_abi && use server ; then
+               if [[ ( -n ${MYSQL_DEFAULT_CHARSET} ) && ( -n 
${MYSQL_DEFAULT_COLLATION} ) ]]; then
+                       ewarn "You are using a custom charset of 
${MYSQL_DEFAULT_CHARSET}"
+                       ewarn "and a collation of ${MYSQL_DEFAULT_COLLATION}."
+                       ewarn "You MUST file bugs without these variables set."
+
+                       mycmakeargs+=(
+                               -DDEFAULT_CHARSET=${MYSQL_DEFAULT_CHARSET}
+                               -DDEFAULT_COLLATION=${MYSQL_DEFAULT_COLLATION}
+                       )
+
+               elif ! use latin1 ; then
+                       mycmakeargs+=(
+                               -DDEFAULT_CHARSET=utf8
+                               -DDEFAULT_COLLATION=utf8_general_ci
+                       )
+               else
+                       mycmakeargs+=(
+                               -DDEFAULT_CHARSET=latin1
+                               -DDEFAULT_COLLATION=latin1_swedish_ci
+                       )
+               fi
+               mycmakeargs+=(
+                       -DEXTRA_CHARSETS=all
+                       -DMYSQL_USER=mysql
+                       -DMYSQL_UNIX_ADDR=${EPREFIX}/var/run/mysqld/mysqld.sock
+                       -DDISABLE_SHARED=$(usex static YES NO)
+                       -DWITH_DEBUG=$(usex debug)
+                       -DWITH_EMBEDDED_SERVER=$(usex embedded)
+                       -DWITH_PROFILING=$(usex profiling)
+               )
+
+               if use static; then
+                       mycmakeargs+=( -DWITH_PIC=1 )
+               fi
+
+               if use jemalloc || use tcmalloc ; then
+                       mycmakeargs+=( -DWITH_SAFEMALLOC=OFF )
+               fi
+
+               # Storage engines
+               mycmakeargs+=(
+                       -DWITH_ARCHIVE_STORAGE_ENGINE=1
+                       -DWITH_BLACKHOLE_STORAGE_ENGINE=1
+                       -DWITH_CSV_STORAGE_ENGINE=1
+                       -DWITH_HEAP_STORAGE_ENGINE=1
+                       -DWITH_INNOBASE_STORAGE_ENGINE=1
+                       -DWITH_MYISAMMRG_STORAGE_ENGINE=1
+                       -DWITH_MYISAM_STORAGE_ENGINE=1
+                       -DWITH_PARTITION_STORAGE_ENGINE=1
+               )
+
+               mycmakeargs+=( -DWITH_FEDERATED_STORAGE_ENGINE=$(usex 
extraengine) )
+       else
+               mycmakeargs+=(
+                       -DWITHOUT_SERVER=1
+                       -DWITHOUT_EMBEDDED_SERVER=1
+                       -DEXTRA_CHARSETS=none
+                       -DINSTALL_SQLBENCHDIR=
+               )
+       fi
+
+       # systemtap only works on native ABI  bug 530132
+       if multilib_is_native_abi; then
+               mycmakeargs+=( -DENABLE_DTRACE=$(usex systemtap) )
+               [[ ${MYSQL_CMAKE_NATIVE_DEFINES} ]] && mycmakeargs+=( 
${MYSQL_CMAKE_NATIVE_DEFINES} )
+       else
+               mycmakeargs+=( -DENABLE_DTRACE=0 )
+               [[ ${MYSQL_CMAKE_NONNATIVE_DEFINES} ]] && mycmakeargs+=( 
${MYSQL_CMAKE_NONNATIVE_DEFINES} )
+       fi
+
+       [[ ${MYSQL_CMAKE_EXTRA_DEFINES} ]] && mycmakeargs+=( 
${MYSQL_CMAKE_EXTRA_DEFINES} )
+
+       cmake-utils_src_configure
+}
+
+mysql-multilib-r1_src_compile() {
+       local _cmake_args=( "${@}" )
+
+       multilib-minimal_src_compile
+}
+
+multilib_src_compile() {
+
+       cmake-utils_src_compile "${_cmake_args[@]}"
+}
+
+
+# @FUNCTION: mysql-multilib_src_install
+# @DESCRIPTION:
+# Install mysql.
+mysql-multilib-r1_src_install() {
+       # wrap the config script
+       MULTILIB_CHOST_TOOLS=( /usr/bin/mysql_config )
+
+       multilib-minimal_src_install
+}
+
+multilib_src_install() {
+       debug-print-function ${FUNCNAME} "$@"
+
+       if multilib_is_native_abi; then
+               # Make sure the vars are correctly initialized
+               mysql_init_vars
+
+               cmake-utils_src_install
+
+               # Convenience links
+               einfo "Making Convenience links for mysqlcheck multi-call 
binary"
+               dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
+               dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
+               dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
+
+               # INSTALL_LAYOUT=STANDALONE causes cmake to create a /usr/data 
dir
+               if [[ -d "${ED}/usr/data" ]] ; then
+                       rm -Rf "${ED}/usr/data" || die
+               fi
+
+               # Unless they explicitly specific USE=test, then do not install 
the
+               # testsuite. It DOES have a use to be installed, esp. when you 
want to do a
+               # validation of your database configuration after tuning it.
+               if ! use test ; then
+                       rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
+               fi
+
+               # Configuration stuff
+               case ${MYSQL_PV_MAJOR} in
+                       5.5) mysql_mycnf_version="5.5" ;;
+                       5.[6-9]|6*|7*|8*|9*|10*) mysql_mycnf_version="5.6" ;;
+               esac
+               einfo "Building default my.cnf (${mysql_mycnf_version})"
+               insinto "${MY_SYSCONFDIR#${EPREFIX}}"
+               [[ -f "${S}/scripts/mysqlaccess.conf" ]] && doins 
"${S}"/scripts/mysqlaccess.conf
+               mycnf_src="my.cnf-${mysql_mycnf_version}"
+               sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
+                       "${FILESDIR}/${mycnf_src}" \
+                       > "${TMPDIR}/my.cnf.ok" || die
+               use prefix && sed -i -r -e 
'/^user[[:space:]]*=[[:space:]]*mysql$/d' "${TMPDIR}/my.cnf.ok"
+               if use latin1 ; then
+                       sed -i \
+                               -e "/character-set/s|utf8|latin1|g" \
+                               "${TMPDIR}/my.cnf.ok" || die
+               fi
+               eprefixify "${TMPDIR}/my.cnf.ok"
+               newins "${TMPDIR}/my.cnf.ok" my.cnf
+
+               if use server ; then
+                       einfo "Creating initial directories"
+                       # Empty directories ...
+                       diropts "-m0750"
+                       if [[ ${PREVIOUS_DATADIR} != "yes" ]] ; then
+                               dodir "${MY_DATADIR#${EPREFIX}}"
+                               keepdir "${MY_DATADIR#${EPREFIX}}"
+                               chown -R mysql:mysql "${D}/${MY_DATADIR}"
+                       fi
+
+                       diropts "-m0755"
+                       for folder in "${MY_LOGDIR#${EPREFIX}}" ; do
+                               dodir "${folder}"
+                               keepdir "${folder}"
+                               chown -R mysql:mysql "${ED}/${folder}"
+                       done
+
+                       einfo "Including support files and sample 
configurations"
+                       docinto "support-files"
+                       for script in \
+                               "${S}"/support-files/my-*.cnf.sh \
+                               "${S}"/support-files/magic \
+                               "${S}"/support-files/ndb-config-2-node.ini.sh
+                       do
+                               [[ -f $script ]] && dodoc "${script}"
+                       done
+
+                       docinto "scripts"
+                       for script in "${S}"/scripts/mysql* ; do
+                               [[ ( -f $script ) && ( ${script%.sh} == 
${script} ) ]] && dodoc "${script}"
+                       done
+               fi
+
+               #Remove mytop if perl is not selected
+               [[ -e "${ED}/usr/bin/mytop" ]] && ! use perl && rm -f 
"${ED}/usr/bin/mytop"
+
+               # Percona has decided to rename libmysqlclient to 
libperconaserverclient
+               # Use a symlink to preserve linkages for those who don't use 
mysql_config
+               local suffix
+               for suffix in ".so" "_r.so" ".a" "_r.a" ; do
+                       if [[ -e 
"${ED}/usr/$(get_libdir)/libperconaserverclient${suffix}" ]] ; then
+                               dosym libperconaserverclient${suffix} 
/usr/$(get_libdir)/libmysqlclient${suffix}
+                       fi
+               done
+       else
+               cmake-utils_src_install
+               if [[ "${PN}" == "mariadb" ]] && use server ; then
+                       insinto /usr/include/mysql/private
+                       doins "${S}"/sql/*.h
+               fi
+       fi
+}
+
+# @FUNCTION: mysql-multilib_pkg_preinst
+# @DESCRIPTION:
+mysql-multilib-r1_pkg_preinst() {
+       debug-print-function ${FUNCNAME} "$@"
+
+       # Here we need to see if the implementation switched client libraries
+       # We check if this is a new instance of the package and a client 
library already exists
+       local SHOW_ABI_MESSAGE
+        if [[ -z ${REPLACING_VERSIONS} && -e 
"${EROOT}usr/$(get_libdir)/libmysqlclient.so" ]] ; then
+                elog "Due to ABI changes when switching between different 
client libraries,"
+                elog "revdep-rebuild must find and rebuild all packages 
linking to libmysqlclient."
+                elog "Please run: revdep-rebuild --library 
libmysqlclient.so.${SUBSLOT:-18}"
+                ewarn "Failure to run revdep-rebuild may cause issues with 
other programs or libraries"
+        fi
+}
+
+# @FUNCTION: mysql-multilib-r1_pkg_postinst
+# @DESCRIPTION:
+# Run post-installation tasks:
+#   create the dir for logfiles if non-existant
+#   touch the logfiles and secure them
+#   install scripts
+#   issue required steps for optional features
+#   issue deprecation warnings
+mysql-multilib-r1_pkg_postinst() {
+       debug-print-function ${FUNCNAME} "$@"
+
+       # Make sure the vars are correctly initialized
+       mysql_init_vars
+
+       # Check FEATURES="collision-protect" before removing this
+       [[ -d "${ROOT}${MY_LOGDIR}" ]] || install -d -m0750 -o mysql -g mysql 
"${ROOT}${MY_LOGDIR}"
+
+       # Secure the logfiles
+       touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
+       chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
+       chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
+
+       # Minimal builds don't have the MySQL server
+       if use server ; then
+               docinto "support-files"
+               for script in \
+                       support-files/my-*.cnf \
+                       support-files/magic \
+                       support-files/ndb-config-2-node.ini
+               do
+                       [[ -f "${script}" ]] \
+                       && dodoc "${script}"
+               done
+
+               docinto "scripts"
+               for script in scripts/mysql* ; do
+                       if [[ -f "${script}" && "${script%.sh}" == "${script}" 
]]; then
+                               dodoc "${script}"
+                       fi
+               done
+
+               if use_if_iuse pam ; then
+                       einfo
+                       elog "This install includes the PAM authentication 
plugin."
+                       elog "To activate and configure the PAM plugin, please 
read:"
+                       if [[ ${PN} == "mariadb" ]] ; then
+                               elog 
"https://mariadb.com/kb/en/mariadb/pam-authentication-plugin/";
+                       elif [[ ${PN} == "percona-server" ]] ; then
+                               elog 
"https://www.percona.com/doc/percona-server/5.6/management/pam_plugin.html";
+                       fi
+                       einfo
+               fi
+
+               if [[ -z "${REPLACING_VERSIONS}" ]] ; then
+                       einfo
+                       elog "You might want to run:"
+                       elog "\"emerge --config =${CATEGORY}/${PF}\""
+                       elog "if this is a new install."
+                       elog
+                       elog "If you are switching server implentations, you 
should run the"
+                       elog "mysql_upgrade tool."
+                       einfo
+               else
+                       einfo
+                       elog "If you are upgrading major versions, you should 
run the"
+                       elog "mysql_upgrade tool."
+                       einfo
+               fi
+
+               if use_if_iuse galera ; then
+                       einfo
+                       elog "Be sure to edit the my.cnf file to activate your 
cluster settings."
+                       elog "This should be done after running \"emerge 
--config =${CATEGORY}/${PF}\""
+                       elog "The first time the cluster is activated, you 
should add"
+                       elog "--wsrep-new-cluster to the options in 
/etc/conf.d/mysql for one node."
+                       elog "This option should then be removed for subsequent 
starts."
+                       einfo
+               fi
+       fi
+}
+
+# @FUNCTION: mysql-multilib-r1_getopt
+# @DESCRIPTION:
+# Use my_print_defaults to extract specific config options
+mysql-multilib-r1_getopt() {
+       local mypd="${EROOT}"/usr/bin/my_print_defaults
+       section="$1"
+       flag="--${2}="
+       "${mypd}" $section | sed -n "/^${flag}/p"
+}
+
+# @FUNCTION: mysql-multilib-r1_getoptval
+# @DESCRIPTION:
+# Use my_print_defaults to extract specific config options
+mysql-multilib-r1_getoptval() {
+       local mypd="${EROOT}"/usr/bin/my_print_defaults
+       local section="$1"
+       local flag="--${2}="
+       local extra_options="${3}"
+       "${mypd}" $extra_options $section | sed -n "/^${flag}/s,${flag},,gp"
+}
+
+# @FUNCTION: mysql-multilib_pkg_config
+# @DESCRIPTION:
+# Configure mysql environment.
+mysql-multilib-r1_pkg_config() {
+
+       debug-print-function ${FUNCNAME} "$@"
+
+       local old_MY_DATADIR="${MY_DATADIR}"
+       local old_HOME="${HOME}"
+       # my_print_defaults needs to read stuff in $HOME/.my.cnf
+       export HOME=${EPREFIX}/root
+
+       # Make sure the vars are correctly initialized
+       mysql_init_vars
+
+       [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR"
+       if ! built_with_use ${CATEGORY}/${PN} server ; then
+               die "Minimal builds do NOT include the MySQL server"
+       fi
+
+       if [[ ( -n "${MY_DATADIR}" ) && ( "${MY_DATADIR}" != 
"${old_MY_DATADIR}" ) ]]; then
+               local MY_DATADIR_s="${ROOT}/${MY_DATADIR}"
+               MY_DATADIR_s="${MY_DATADIR_s%%/}"
+               local old_MY_DATADIR_s="${ROOT}/${old_MY_DATADIR}"
+               old_MY_DATADIR_s="${old_MY_DATADIR_s%%/}"
+
+               if [[ ( -d "${old_MY_DATADIR_s}" ) && ( "${old_MY_DATADIR_s}" 
!= / ) ]]; then
+                       if [[ -d "${MY_DATADIR_s}" ]]; then
+                               ewarn "Both ${old_MY_DATADIR_s} and 
${MY_DATADIR_s} exist"
+                               ewarn "Attempting to use ${MY_DATADIR_s} and 
preserving ${old_MY_DATADIR_s}"
+                       else
+                               elog "Moving MY_DATADIR from 
${old_MY_DATADIR_s} to ${MY_DATADIR_s}"
+                               mv --strip-trailing-slashes -T 
"${old_MY_DATADIR_s}" "${MY_DATADIR_s}" \
+                               || die "Moving MY_DATADIR failed"
+                       fi
+               else
+                       ewarn "Previous MY_DATADIR (${old_MY_DATADIR_s}) does 
not exist"
+                       if [[ -d "${MY_DATADIR_s}" ]]; then
+                               ewarn "Attempting to use ${MY_DATADIR_s}"
+                       else
+                               eerror "New MY_DATADIR (${MY_DATADIR_s}) does 
not exist"
+                               die "Configuration Failed! Please reinstall 
${CATEGORY}/${PN}"
+                       fi
+               fi
+       fi
+
+       local pwd1="a"
+       local pwd2="b"
+       local maxtry=15
+
+       if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then
+               MYSQL_ROOT_PASSWORD="$(mysql-multilib-r1_getoptval 'client 
mysql' password)"
+               # Sometimes --show is required to display passwords in some 
implementations of my_print_defaults
+               if [[ "${MYSQL_ROOT_PASSWORD}" == '*****' ]]; then
+                       MYSQL_ROOT_PASSWORD="$(mysql-multilib-r1_getoptval 
'client mysql' password --show)"
+               fi
+       fi
+       MYSQL_TMPDIR="$(mysql-multilib-r1_getoptval mysqld tmpdir)"
+       # These are dir+prefix
+       MYSQL_RELAY_LOG="$(mysql-multilib-r1_getoptval mysqld relay-log)"
+       MYSQL_RELAY_LOG=${MYSQL_RELAY_LOG%/*}
+       MYSQL_LOG_BIN="$(mysql-multilib-r1_getoptval mysqld log-bin)"
+       MYSQL_LOG_BIN=${MYSQL_LOG_BIN%/*}
+
+       if [[ ! -d "${ROOT}"/$MYSQL_TMPDIR ]]; then
+               einfo "Creating MySQL tmpdir $MYSQL_TMPDIR"
+               install -d -m 770 -o mysql -g mysql "${EROOT}"/$MYSQL_TMPDIR
+       fi
+       if [[ ! -d "${ROOT}"/$MYSQL_LOG_BIN ]]; then
+               einfo "Creating MySQL log-bin directory $MYSQL_LOG_BIN"
+               install -d -m 770 -o mysql -g mysql "${EROOT}"/$MYSQL_LOG_BIN
+       fi
+       if [[ ! -d "${EROOT}"/$MYSQL_RELAY_LOG ]]; then
+               einfo "Creating MySQL relay-log directory $MYSQL_RELAY_LOG"
+               install -d -m 770 -o mysql -g mysql "${EROOT}"/$MYSQL_RELAY_LOG
+       fi
+
+       if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
+               ewarn "You have already a MySQL database in place."
+               ewarn "(${ROOT}/${MY_DATADIR}/*)"
+               ewarn "Please rename or delete it if you wish to replace it."
+               die "MySQL database already exists!"
+       fi
+
+       # Bug #213475 - MySQL _will_ object strenously if your machine is named
+       # localhost. Also causes weird failures.
+       [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be 
named localhost"
+
+       if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then
+
+               einfo "Please provide a password for the mysql 'root' user now"
+               einfo "or through the ${HOME}/.my.cnf file."
+               ewarn "Avoid [\"'\\_%] characters in the password"
+               read -rsp "    >" pwd1 ; echo
+
+               einfo "Retype the password"
+               read -rsp "    >" pwd2 ; echo
+
+               if [[ "x$pwd1" != "x$pwd2" ]] ; then
+                       die "Passwords are not the same"
+               fi
+               MYSQL_ROOT_PASSWORD="${pwd1}"
+               unset pwd1 pwd2
+       fi
+
+       local options
+       local sqltmp="$(emktemp)"
+
+       # Fix bug 446200. Don't reference host my.cnf, needs to come first,
+       # see http://bugs.mysql.com/bug.php?id=31312
+       use prefix && options="${options} 
'--defaults-file=${MY_SYSCONFDIR}/my.cnf'"
+
+       local help_tables="${ROOT}${MY_SHAREDSTATEDIR}/fill_help_tables.sql"
+       [[ -r "${help_tables}" ]] \
+       && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
+       || touch "${TMPDIR}/fill_help_tables.sql"
+       help_tables="${TMPDIR}/fill_help_tables.sql"
+
+       # Figure out which options we need to disable to do the setup
+       local helpfile="${TMPDIR}/mysqld-help"
+       ${EROOT}/usr/sbin/mysqld --verbose --help >"${helpfile}" 2>/dev/null
+       for opt in grant-tables host-cache name-resolve networking slave-start \
+               federated ssl log-bin relay-log slow-query-log external-locking 
\
+               ndbcluster log-slave-updates \
+               ; do
+               optexp="--(skip-)?${opt}" optfull="--loose-skip-${opt}"
+               egrep -sq -- "${optexp}" "${helpfile}" && options="${options} 
${optfull}"
+       done
+       # But some options changed names
+       egrep -sq external-locking "${helpfile}" && \
+       options="${options/skip-locking/skip-external-locking}"
+
+       use prefix || options="${options} --user=mysql"
+
+       einfo "Creating the mysql database and setting proper permissions on it 
..."
+
+       # Now that /var/run is a tmpfs mount point, we need to ensure it exists 
before using it
+       PID_DIR="${EROOT}/var/run/mysqld"
+       if [[ ! -d "${PID_DIR}" ]]; then
+               mkdir -p "${PID_DIR}" || die "Could not create pid directory"
+               chown mysql:mysql "${PID_DIR}" || die "Could not set ownership 
on pid directory"
+               chmod 755 "${PID_DIR}" || die "Could not set permissions on pid 
directory"
+       fi
+
+       pushd "${TMPDIR}" &>/dev/null
+
+       # Filling timezones, see
+       # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
+       "${EROOT}/usr/bin/mysql_tzinfo_to_sql" "${EROOT}/usr/share/zoneinfo" > 
"${sqltmp}" 2>/dev/null
+
+       local cmd
+       local initialize_options
+        if [[ ${PN} == "mysql" || ${PN} == "percona-server" ]] && 
mysql_version_is_at_least "5.7.6" ; then
+               # --initialize-insecure will not set root password
+               # --initialize would set a random one in the log which we don't 
need as we set it ourselves
+               cmd="${EROOT}usr/sbin/mysqld"
+               initialize_options="--initialize-insecure  
'--init-file=${sqltmp}'"
+               sqltmp="" # the initialize will take care of it
+       else
+               cmd="${EROOT}usr/share/mysql/scripts/mysql_install_db"
+               [[ -f "${cmd}" ]] || cmd="${EROOT}usr/bin/mysql_install_db"
+               if [[ -r "${help_tables}" ]] ; then
+                       cat "${help_tables}" >> "${sqltmp}"
+               fi
+       fi
+       cmd="'$cmd' '--basedir=${EPREFIX}/usr' ${options} 
'--datadir=${ROOT}/${MY_DATADIR}' '--tmpdir=${ROOT}/${MYSQL_TMPDIR}' 
${initialize_options}"
+       einfo "Command: $cmd"
+       eval $cmd \
+               >"${TMPDIR}"/mysql_install_db.log 2>&1
+       if [ $? -ne 0 ]; then
+               grep -B5 -A999 -i "ERROR" "${TMPDIR}"/mysql_install_db.log 1>&2
+               die "Failed to initialize mysqld. Please review 
${EPREFIX}/var/log/mysql/mysqld.err AND ${TMPDIR}/mysql_install_db.log"
+       fi
+       popd &>/dev/null
+       [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
+       || die "MySQL databases not installed"
+       chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
+       chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
+
+       local socket="${EROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
+       local pidfile="${EROOT}/var/run/mysqld/mysqld${RANDOM}.pid"
+       local mysqld="${EROOT}/usr/sbin/mysqld \
+               ${options} \
+               $(use prefix || echo --user=mysql) \
+               --log-warnings=0 \
+               --basedir=${EROOT}/usr \
+               --datadir=${ROOT}/${MY_DATADIR} \
+               --max_allowed_packet=8M \
+               --net_buffer_length=16K \
+               --default-storage-engine=MyISAM \
+               --socket=${socket} \
+               --pid-file=${pidfile}
+               --tmpdir=${ROOT}/${MYSQL_TMPDIR}"
+       #einfo "About to start mysqld: ${mysqld}"
+       ebegin "Starting mysqld"
+       einfo "Command ${mysqld}"
+       ${mysqld} &
+       rc=$?
+       while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do
+               maxtry=$((${maxtry}-1))
+               echo -n "."
+               sleep 1
+       done
+       eend $rc
+
+       if ! [[ -S "${socket}" ]]; then
+               die "Completely failed to start up mysqld with: ${mysqld}"
+       fi
+
+       ebegin "Setting root password"
+       # Do this from memory, as we don't want clear text passwords in temp 
files
+       local sql="UPDATE mysql.user SET Password = 
PASSWORD('${MYSQL_ROOT_PASSWORD}') WHERE USER='root'"
+       "${EROOT}/usr/bin/mysql" \
+               --socket=${socket} \
+               -hlocalhost \
+               -e "${sql}"
+       eend $?
+
+       if [[ -n "${sqltmp}" ]] ; then
+               ebegin "Loading \"zoneinfo\", this step may require a few 
seconds"
+               "${EROOT}/usr/bin/mysql" \
+                       --socket=${socket} \
+                       -hlocalhost \
+                       -uroot \
+                       --password="${MYSQL_ROOT_PASSWORD}" \
+                       mysql < "${sqltmp}"
+               rc=$?
+               eend $?
+               [[ $rc -ne 0 ]] && ewarn "Failed to load zoneinfo!"
+       fi
+
+       # Stop the server and cleanup
+       einfo "Stopping the server ..."
+       kill $(< "${pidfile}" )
+       rm -f "${sqltmp}"
+       wait %1
+       einfo "Done"
+}
+
+
+#
+# HELPER FUNCTIONS:
+#
+
+# @FUNCTION: mysql-multilib-r1_disable_test
+# @DESCRIPTION:
+# Helper function to disable specific tests.
+mysql-multilib-r1_disable_test() {
+
+       local rawtestname testname testsuite reason mysql_disabled_file 
mysql_disabled_dir
+       rawtestname="${1}" ; shift
+       reason="${@}"
+       ewarn "test '${rawtestname}' disabled: '${reason}'"
+
+       testsuite="${rawtestname/.*}"
+       testname="${rawtestname/*.}"
+       for mysql_disabled_file in \
+               ${S}/mysql-test/disabled.def \
+               ${S}/mysql-test/t/disabled.def ; do
+               [[ -f ${mysql_disabled_file} ]] && break
+       done
+       #mysql_disabled_file="${S}/mysql-test/t/disabled.def"
+       #einfo "rawtestname=${rawtestname} testname=${testname} 
testsuite=${testsuite}"
+       echo ${testname} : ${reason} >> "${mysql_disabled_file}"
+
+       if [[ ( -n ${testsuite} ) && ( ${testsuite} != "main" ) ]]; then
+               for mysql_disabled_file in \
+                       ${S}/mysql-test/suite/${testsuite}/disabled.def \
+                       ${S}/mysql-test/suite/${testsuite}/t/disabled.def \
+                       FAILED ; do
+                       [[ -f ${mysql_disabled_file} ]] && break
+               done
+               if [[ ${mysql_disabled_file} != "FAILED" ]]; then
+                       echo "${testname} : ${reason}" >> 
"${mysql_disabled_file}"
+               else
+                       for mysql_disabled_dir in \
+                               ${S}/mysql-test/suite/${testsuite} \
+                               ${S}/mysql-test/suite/${testsuite}/t \
+                               FAILED ; do
+                               [[ -d ${mysql_disabled_dir} ]] && break
+                       done
+                       if [[ ${mysql_disabled_dir} != "FAILED" ]]; then
+                               echo "${testname} : ${reason}" >> 
"${mysql_disabled_dir}/disabled.def"
+                       else
+                               ewarn "Could not find testsuite disabled.def 
location for ${rawtestname}"
+                       fi
+               fi
+       fi
+}
+
+# @FUNCTION: mysql-cmake_use_plugin
+# @DESCRIPTION:
+# Helper function to enable/disable plugins by use flags
+# cmake-utils_use_with is not enough as some references check WITH_ (0|1)
+# and some check WITHOUT_. Also, this can easily extend to non-storage plugins.
+mysql-cmake_use_plugin() {
+       [[ -z $2 ]] && die "mysql-cmake_use_plugin <USE flag> <flag name>"
+       if use_if_iuse $1 ; then
+               echo "-DWITH_$2=1 -DPLUGIN_$2=YES"
+       else
+               echo "-DWITHOUT_$2=1 -DWITH_$2=0 -DPLUGIN_$2=NO"
+       fi
+}

Reply via email to